import { input, span, text, button } from "@hyperapp/html"
import { withFocus } from "./lib/decorators.js"
import { editable } from "./lib/view.js"

export default (props) =>
  editable(
    {
      id: "todo-input",
      editing: props.editing,
      value: props.value,
      oninput: props.oninput,
      ondone: props.ondone
    },
    [
      input({
        type: "checkbox",
        checked: props.checked,
        oninput: props.ontoggle
      }),
      span(
        {
          onclick: withFocus(props.onedit, "#todo-input"),
          class: { done: props.checked }
        },
        text(props.value)
      ),
      button({ onclick: props.ondelete }, text("X"))
    ]
  )
